//Remaps
if(!$RTB_ircWithChat)
{
	//Division
   $remapDivision[$remapCount] = "IRC to Chat";
   
   //Count
   $remapName[$remapCount] = "Open / Close the message hud.";
   
   //Command
   $remapCmd[$remapCount] = "RTB_ircMH";
   
   //Add to variable
   $remapCount++;
   
   	//Division
   $remapDivision[$remapCount] = "IRC to Chat Toggler";
   
   //Count
   $remapName[$remapCount] = "Set a hotkey to enable or disable Irc to Chat";
   
   //Command
   $remapCmd[$remapCount] = "RTB_ircToggle";
   
   //Add to variable
   $remapCount++;
   
   //Sets true
   $RTB_ircWithChat = true;
}

//RTB In Game Chat Package Defined
package RTB_IGChat
{
	//When some body gets kicked
	function RTBIC_SC::onKick(%this, %mid, %info)
	{
		//Parent
		parent::onKick(%this,%mid,%info);
		
		if(isObject(serverConnection) && isObject(newChatSo) && $pref::irctochat)
		{
			//Check
			if(strStr(%info,":Spamming") >= 0)
			{
				//Set reason
				%for = "Spamming";
			}
			else
			//Check
			if(strStr(%info,":Excessive Caps") >= 0)
			{
				//Set reason
				%for = "Excessive Caps";
			}
			else
			//Check
			if(strStr(%info,":Flooding") >= 0)
			{
				//Set reason
				%for = "Flooding";
			}
			else
			{
				//Set reason
				%for = "Other";
			}
			//Get the name of the individual being kicked
			%name = getSubstr(%info,strStr(%info,"#rtb ")+5,strStr(%info," :"@%for)-5);
			//Add line
			newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/notice><color:fff000>[<bitmap:add-ons/client_ircToChat/irc>] BlockBot<color:ffffff>: I have kicked "@%name@" ["@%for@"]");
		}
	}

	//Data necessary to update our IRC client
	function RTBIC_SC::onLine(%this, %info)
	{
		//Call the parent as not to overwrite this function
		parent::onLine(%this, %info);
		
		//Are we in a game and RTB pref is true
		if(isObject(serverConnection) && isObject(newChatSo) && $pref::irctochat)
		{
			//No getSubStr errors
			if(strStr(%info,"!Block") >= 0)
			{
				//Gets the name of an active irc member
				%name = getSubStr(%info,strStr(%info,":")+1,strStr(%info,"!Block")-1);
			}
			
			//Message data
			//------------
			%msg = getSubStr(%info,strStr(%info,":")+1,strLen(%info));
			%msg = getSubStr(%msg,strStr(%msg,":")+1,strLen(%msg));
			//------------

			//If the member is sending a message to the main RTB chat window
			if(strStr(%info,"PRIVMSG #rtb") >= 0)
			{
				//Sets false
				%pmsg = false;
			}
			else
			//If the member is sending a message to us, via private message
			if(striStr(%info,"PRIVMSG "@ getIRCName()) >= 0)
			{
				//Sets true
				%pmsg = true;
			}
			//If none of the above, then nullify
			else
			{
				//Sets null
				%pmsg = null;
			}

			//Let's intercept the data
			interceptMsg(%msg,%name,%pmsg);
		}
	}
	
	//When you type in the chat box..
	function nmh_type::type(%this)
	{
		//Call the parent..
		parent::type(%this);
		
		//Are we using the RTB channel?
		if(nmh_channel.getValue() $= "RTB:" && $pref::irctochat)
		{
			//Sets message
			%m = %this.getValue();
			
			//Calling for a quick reply and do we have a replie?
			if(%m $= "/r " && $RTB::lastMessager !$= "")
			{
				//Set the channel value
				%this.setValue("/pm " @ $RTB::lastMessager @ " ");
			}
		}
	}
	
	//When we send a message
	function nmh_type::send(%this)
	{
		//Sets message
		%m = %this.getValue();
		
		//Are we in the RTB channel?
		if(nmh_channel.getValue() $= "RTB:" && $pref::irctochat)
		{
			//Are we private messaging?
			if(getWord(%m,0) !$= "/pm")
			{
				//Fix up the message
				%msg = getWords(%m,0,getWordCount(%m));
				
				//Is our new message valid?
				if(getWordCount(%msg) >= 1)
				{
					//Strip ML things
					%msg = stripMlControlChars(%msg);
					
					//Add tag
					%msg = "[i2c] - "@%msg;
					
					//Sends a line people can see, but we cant..
					RTBIC_SC.sendLine("PRIVMSG #rtb "@ %msg);
					
					//Now we can see what we have sent..
					RTBIC_addLine("<"@getIrcName()@"> " @%msg);
					
					//Remove tags
					%msg = strReplace(%msg,"[i2c] - ","");
					
					//Show what we've said in our game's chat
					newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/normal><color:fff000>[<bitmap:add-ons/client_ircToChat/irc>] " @ getIRCName() @ "<color:ffffff>: " @ %msg);
				}
			}
			else
			//We are private messaging
			if(getWord(%m,0) $= "/pm")
			{
				//Sets message
				%msg = getWords(%m,1,getWordCount(%m));
				
				//Gets a name from a string, if it contains one..
				%name = getIrcNameFrom(%msg);
				
				//Fix up the message
				%msg = getWords(%msg,getWordCount(%name),getWordCount(%msg));
				
				//Custom null if %name returned so
				if(%name $= "00null00")
				{
					//Sends us an , "error invalid or not available message"
					newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/error>[<bitmap:add-ons/client_ircToChat/irc>] - User is invalid, or not connected.");
				}
				else
				//Is %msg valid?
				if(getWordCount(%msg) >= 1)
				{
					%msg = stripMlControlChars(%msg);
					
					%msg = "[i2c] - "@%msg;
					
					//Sends line so the target can see
					RTBIC_SC.sendLine("PRIVMSG "@ %name SPC %msg);
					
					%msg = strReplace(%msg,"[i2c] - ","");
					
					//This needs to be called to get the session & send the line
					//-----------------
					if(RTBIC_hasSession(%name))
					{
						%currsess = RTBIC_getSession(%name); 
						%currsess.window.messageVector.pushBackLine("<"@getIrcName()@"> " @%msg,0);
					}
					else
					{
						RTBIC_createSession(%name);
						%currsess = RTBIC_getSession(%name); 
						%currsess.window.messageVector.pushBackLine("<"@getIrcName()@"> " @%msg,0);
					}
					//-----------------
					
					//Show our message in our game's chat
					newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/pm><color:fff000>[<bitmap:add-ons/client_ircToChat/irc>] " @ getIrcName() @ "<color:ffffff>: " @ %msg);
				}
			}
			
			//Close the message hud
			canvas.popDialog(newMessageHud);
		}
		else
		{
			if(!$pref::irctochat && nmh_channel.getValue() $= "RTB:")
			{
				//Warn user
				newChatSo.addLine("<bitmap:add-ons/client_ircToChat/error>[<bitmap:add-ons/client_ircToChat/irc>]IRC to chat is not enabled, go to your options to enable it with a hotkey.");
				
				//Close the message hud
				canvas.popDialog(newMessageHud);
				
				//return
				return;
			}
			//Parent
			parent::send(%this);
		}
	}
};
//Activate our package..
activatePackage(RTB_IGChat);

//Handles data
function interceptMsg(%msg,%name,%pmsg)
{
	//Is user ignored?
	if($ignore::user[%name])
	{
		//Return
		return "Ignored "@%name;
	}
	
	//Strip Ml things
	%msg = stripMlControlChars(%msg);
	
	//Replace tag
	%msg = strReplace(%msg,"[i2c] - ","");
	
	//If not null
	if(%pmsg !$= null)
	{
		//Was it a private message?
		if(%pmsg == true)
		{
			//Add chat to our current game's chat
			newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/pm><color:fff000>[<bitmap:add-ons/client_ircToChat/irc>] " @ %name @ "<color:ffffff>: " @ %msg);
			$RTB::lastMessager = %name;
		}
		//It wasn't a private message
		else
		{
			//Add chat to our current game's chat
			newChatSo.addLine("<font:arial:20><bitmap:add-ons/client_ircToChat/normal><color:fff000>[<bitmap:add-ons/client_ircToChat/irc>] " @ %name @ "<color:ffffff>: " @ %msg);
		}
	}
}

//Get's clients current IRC name
function getIRCName()
{
	//Do we have a custom IRC name?
	if($RTB::Options::IC::CustomUsername)
	{
		//Sets name to our current custom name
		%name = $RTB::Options::IC::CustomUser;
	}
	//If not..
	else
	{
		//Sets name to netname
		%name = $pref::Player::NetName;
	}
	
	//Returns our current IRC name
	return %name;
}

//Gets an irc name from a string, if possible
function getIrcNameFrom(%string)
{
	//Loop through the connected users
	for(%i=0; %i<RTBIC_UserList.rowCount(); %i++)
	{
		//Defines name
		//-------------
		%name = RTBIC_UserList.getRowText(%i);
		%name = getSubStr(%name,2,strLen(%name));
		//-------------

		//strStr customized
		if(striStr(%string,%name) >= 0)
		{
			//Return our name
			return %name;
		}
	}
	
	//Return our custom null
	return "00null00";
}

//Irc message hud for in game purposes
function RTB_ircMH()
{
	//Opens the message hud
	newMessageHud.open(say);
	
	//Sets the channel to RTB
	nmh_channel.setText("RTB:");
}

//Toggles
function RTB_ircToggle(%val)
{
	if(%val)
	{
		//This
		if($pref::irctochat == 1 && getSimTime() - $lastirctoggle >= 500)
		{
			$pref::irctochat = false;
			$lastirctoggle = getSimTime();
			if(isObject(serverConnection))
				newChatSo.addline("<bitmap:add-ons/client_ircToChat/notice> IRC To Chat Disabled!");
		}
	}
	else
	{
		//That
		if($pref::irctochat == 0 && getSimTime() - $lastirctoggle >= 500)
		{
			$pref::irctochat = true;
			$lastirctoggle = getSimTime();
			if(isObject(serverConnection))
				newChatSo.addLine("<bitmap:add-ons/client_ircToChat/notice> IRC To Chat Enabled!");
		}
	}
}

//strStr non case sensitive
function striStr(%str,%stri)
{
	//Return
	return strStr(strLwr(%str),strLwr(%stri));
}